SystemOrganization addCategory: #ConfigurationOfMagmaPharo!

Object subclass: #ConfigurationOfMagmaPharo
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMagmaPharo'!

!ConfigurationOfMagmaPharo class methodsFor: 'development support' stamp: 'StuartHerring 6/16/2012 12:48'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMagmaPharo class methodsFor: 'private' stamp: 'StuartHerring 6/16/2012 12:48'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMagmaPharo class methodsFor: 'private' stamp: 'StuartHerring 6/16/2012 12:48'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMagmaPharo class methodsFor: 'private' stamp: 'StuartHerring 6/16/2012 12:48'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMagmaPharo class methodsFor: 'metacello tool support' stamp: 'StuartHerring 6/16/2012 12:48'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMagmaPharo class methodsFor: 'loading' stamp: 'StuartHerring 6/16/2012 12:48'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMagmaPharo class methodsFor: 'loading' stamp: 'StuartHerring 6/16/2012 12:48'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMagmaPharo class methodsFor: 'loading' stamp: 'StuartHerring 6/16/2012 12:48'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMagmaPharo class methodsFor: 'accessing' stamp: 'StuartHerring 6/16/2012 12:48'!
project

	^self new project! !

!ConfigurationOfMagmaPharo class methodsFor: 'development support' stamp: 'StuartHerring 6/16/2012 12:48'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMagmaPharo methodsFor: 'baselines' stamp: 'StuartHerring 6/24/2012 10:54'!
baseline13: spec
	<version: '1.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.

		" MaBase "
		spec repository: 'http://squeaksource.com/MaBase'.
		spec 
			package: 'Collections-BTree';
			package: 'Ma-Core';
			package: 'Ma-Collections' with: [ spec requires: #('Collections-BTree' 'Ma-Core')];
			package: 'Ma-Ascii-Report' with: [ spec requires: #('Ma-Core')];
			package: 'Ma-Statistics' with: [spec requires: #('Ma-Core' 'Ma-Ascii-Report')];
			package: 'Ma-Search' with: [spec requires: #('Ma-Core')];
			package: 'Ma-Serializer-Core' with: [spec requires: #('Ma-Statistics' 'Ma-Collections' )];
			package: 'Ma-Serializer-Tests' with: [ spec requires: #('Ma-Serializer-Core' 'Ma-Search'). ].
		spec 
			group: 'Ma Base' with: #('Collections-BTree' 'Ma-Core' 'Ma-Collections' 'Ma-Ascii-Report' 'Ma-Statistics' 'Ma-Search' 'Ma-Serializer-Core');
			group: 'Ma Base Tests' with: #('Ma Base' 'Ma-Serializer-Tests').
			
		"Ma Client Server"
		spec project: 'OSProcess' with: [
			spec
				className: 'ConfigurationOfOSProcess';
				repository: 'http://squeaksource.com/MetacelloRepository';
				versionString: '4.4.5'].
		spec repository: 'http://squeaksource.com/MaClientServer'.
		spec 
			package: 'Ma-Client-Server-Core' with: [ spec requires: #('Ma-Core' 'Ma-Serializer-Core')];
			package: 'Ma-Client-Server-Tester' with: [ spec requires:#( 'Ma-Client-Server-Core' 'OSProcess')].
		spec
			group: 'Ma Client Server' with: #('Ma Base'  'Ma-Client-Server-Core');
			group: 'Ma Client Server Tests' with: #('Ma Client Server' 'Ma Base Tests' 'Ma-Client-Server-Tester').

		"Magma Client And Server"
		spec repository: 'http://squeaksource.com/Magma'.
		spec 
			package: 'WriteBarrier';
			package: 'SOLHashTables';
			package: 'Magma-Client' with: [ spec requires: #('SOLHashTables' 'WriteBarrier' 'Ma-Client-Server-Core')].
		
		spec
			package: 'Magma-Server' with: [ spec requires: #('Magma-Client') ];
			package: 'Magma-Tools' with: [ spec requires: #('Magma-Client' 'Magma-Server')].
		"Tester"		
		spec
			package: 'Magma-Tester' with: [ spec requires: #('Magma-Client' 'Magma-Server')].
			
		"Main Groups for loading"
		spec
			group: 'default' with: #('Server' );
			group: 'Client' with: #('Ma Client Server' 'Magma-Client');
			group: 'Server' with: #('Client' 'Magma-Server' 'Magma-Tools');
			group: 'Tests' with: #('Server' 'Client' 'Ma Client Server Tests' 'Ma Base Tests' 'Magma-Tester')
	].
		
	spec for: #'pharo' do: [
		spec
			package: 'Ma-Serializer-Pharo-Core';
			package: 'Ma-Serializer-Core' with: [	 spec requires: #('Ma-Serializer-Pharo-Core') ];
			package: 'Magma-Pharo-Tester' with: [spec requires: #('Ma-Client-Server-Tester')];
			package: 'Magma-Tester' with: [spec requires: #('Magma-Pharo-Tester')]
.	].

	spec for: #'pharo1.4.x' do: [
		spec
			preLoadDoIt: #preLoadForPharo14;
			postLoadDoIt: #postLoadForPharo14 
	].

	spec for: #'pharo2.0.x' do: [
		spec
			preLoadDoIt: #preLoadForPharo20;
			postLoadDoIt: #postLoadForPharo20 
	]! !

!ConfigurationOfMagmaPharo methodsFor: 'baselines' stamp: 'StuartHerring 1/9/2013 19:47'!
baseline14: spec
	<version: '1.4-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.

		" MaBase "
		spec repository: 'http://ss3.gemstone.com/ss/MagmaPharo'.
		spec 
			package: 'Collections-BTree';
			package: 'BrpExtensions';
			package: 'Ma-Core';
			package: 'Ma-Collections' with: [ spec requires: #('Collections-BTree' 'Ma-Core')];
			package: 'Ma-Ascii-Report' with: [ spec requires: #('Ma-Core')];
			package: 'Ma-Statistics' with: [spec requires: #('Ma-Core' 'Ma-Ascii-Report')];
			package: 'Ma-Search' with: [spec requires: #('Ma-Core')];
			package: 'Ma-Serializer-Core' with: [spec requires: #('Ma-Statistics' 'Ma-Collections' )];
			package: 'Ma-Serializer-Tests' with: [ spec requires: #('Ma-Serializer-Core' 'Ma-Search'). ].
		spec 
			group: 'Ma Base' with: #('Collections-BTree' 'Ma-Core' 'Ma-Collections' 'Ma-Ascii-Report' 'Ma-Statistics' 'Ma-Search' 'Ma-Serializer-Core');
			group: 'Ma Base Tests' with: #('Ma Base' 'Ma-Serializer-Tests').
			
		"Ma Client Server"
		spec project: 'OSProcess' with: [
			spec
				className: 'ConfigurationOfOSProcess';
				repository: 'http://squeaksource.com/MetacelloRepository';
				versionString: '4.4.5'].
		spec repository: 'http://ss3.gemstone.com/ss/MagmaPharo'.
		spec 
			package: 'Ma-Client-Server-Core' with: [ spec requires: #('Ma-Core' 'Ma-Serializer-Core')];
			package: 'Ma-Client-Server-Tester' with: [ spec requires:#( 'Ma-Client-Server-Core' 'OSProcess')].
		spec
			group: 'Ma Client Server' with: #('Ma Base'  'Ma-Client-Server-Core');
			group: 'Ma Client Server Tests' with: #('Ma Client Server' 'Ma Base Tests' 'Ma-Client-Server-Tester').

		"Magma Client And Server"
		spec repository: 'http://ss3.gemstone.com/ss/MagmaPharo'.
		spec 
			package: 'WriteBarrier' with: [ spec requires: #('BrpExtensions')];
			package: 'SOLHashTables';
			package: 'Magma-Client' with: [ spec requires: #('SOLHashTables' 'WriteBarrier' 'Ma-Client-Server-Core')].
		
		spec
			package: 'Magma-Server' with: [ spec requires: #('Magma-Client') ];
			package: 'Magma-Tools' with: [ spec requires: #('Magma-Client' 'Magma-Server')].
		"Tester"		
		spec
			package: 'Magma-Tester' with: [ spec requires: #('Magma-Client' 'Magma-Server')].
			
		"Main Groups for loading"
		spec
			group: 'default' with: #('Server' );
			group: 'Client' with: #('Ma Client Server' 'Magma-Client');
			group: 'Server' with: #('Client' 'Magma-Server' 'Magma-Tools');
			group: 'Tests' with: #('Server' 'Client' 'Ma Client Server Tests' 'Ma Base Tests' 'Magma-Tester')
	].
		
	spec for: #'pharo' do: [
		spec
			package: 'Ma-Serializer-Pharo-Core';
			package: 'Ma-Serializer-Core' with: [	 spec requires: #('Ma-Serializer-Pharo-Core') ];
			package: 'Magma-Pharo-Tester' with: [spec requires: #('Ma-Client-Server-Tester')];
			package: 'Magma-Tester' with: [spec requires: #('Magma-Pharo-Tester')]
.	].

	spec for: #'pharo1.4.x' do: [
		spec
			preLoadDoIt: #preLoadForPharo14;
			postLoadDoIt: #postLoadForPharo14 
	].

	spec for: #'pharo2.0.x' do: [
		spec
			preLoadDoIt: #preLoadForPharo20;
			postLoadDoIt: #postLoadForPharo20 
	]! !

!ConfigurationOfMagmaPharo methodsFor: 'symbolic versions' stamp: 'StuartHerring 1/6/2013 16:50'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.4'.
! !

!ConfigurationOfMagmaPharo methodsFor: 'versions' stamp: 'StuartHerring 6/16/2012 18:30'!
postLoadForPharo14
	#(Project TranscriptStream TimeProfileBrowser)
		do: [ :each | (Smalltalk at: each) removeFromSystem ]
! !

!ConfigurationOfMagmaPharo methodsFor: 'versions' stamp: 'StuartHerring 7/30/2012 14:53'!
postLoadForPharo20
	#(Project TranscriptStream TimeProfileBrowser ServerDirectory MethodReference SARInstaller TTCFont TTFontDescription)
		do: [ :each | (Smalltalk at: each) removeFromSystem ]
! !

!ConfigurationOfMagmaPharo methodsFor: 'versions' stamp: 'StuartHerring 6/16/2012 17:50'!
preLoadForPharo14
	Object 
		subclass: #TimeProfileBrowser;
		subclass: #Project;
		subclass: #TranscriptStream
	! !

!ConfigurationOfMagmaPharo methodsFor: 'versions' stamp: 'StuartHerring 7/30/2012 14:53'!
preLoadForPharo20
	Object 
		subclass: #TimeProfileBrowser;
		subclass: #Project;
		subclass: #TranscriptStream;
		subclass: #MethodReference;
		subclass: #SARInstaller;
		subclass: #ServerDirectory;
		subclass: #TTCFont;
		subclass: #TTFontDescription
	! !

!ConfigurationOfMagmaPharo methodsFor: 'accessing' stamp: 'StuartHerring 6/16/2012 12:48'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMagmaPharo methodsFor: 'versions' stamp: 'StuartHerring 6/19/2012 21:58'!
version131: spec
	<version: '1.3.1' imports: #('1.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version
Bring in current post 1.3 updates'.
		spec author: 'StuartHerring'.
		spec timestamp: '6/19/2012 21:58'.
		spec project: 'OSProcess' with: '4.4.5'.
		spec 
			package: 'Collections-BTree' with: 'Collections-BTree-lr.73';
			package: 'Ma-Core' with: 'Ma-Core-cmm.218';
			package: 'Ma-Collections' with: 'Ma-Collections-cmm.133';
			package: 'Ma-Ascii-Report' with: 'Ma-Ascii-Report-cmm.9';
			package: 'Ma-Statistics' with: 'Ma-Statistics-cmm.28';
			package: 'Ma-Search' with: 'Ma-Search-cmm.40';
			package: 'Ma-Serializer-Core' with: 'Ma-Serializer-Core-cmm.282';
			package: 'Ma-Serializer-Tests' with: 'Ma-Serializer-Tests-cmm.40';
			package: 'Ma-Client-Server-Core' with: 'Ma-Client-Server-Core-cmm.220';
			package: 'Ma-Client-Server-Tester' with: 'Ma-Client-Server-Tester-cmm.156';
			package: 'WriteBarrier' with: 'WriteBarrier-cmm.38';
			package: 'SOLHashTables' with: 'SOLHashTables-cmm.16';
			package: 'Magma-Client' with: 'Magma-Client-cmm.618';
			package: 'Magma-Server' with: 'Magma-Server-cmm.447';
			package: 'Magma-Tools' with: 'Magma-Tools-cmm.67';
			package: 'Magma-Tester' with: 'Magma-Tester-cmm.395'. ].

	spec for: #'pharo' do: [
		spec 
			package: 'Ma-Serializer-Pharo-Core' with: 'Ma-Serializer-Pharo-Core-cmm.1';
			package: 'Magma-Pharo-Tester' with: 'Magma-Pharo-Tester-cmm.1'. ].
! !

!ConfigurationOfMagmaPharo methodsFor: 'versions' stamp: 'StuartHerring 6/16/2012 16:19'!
version13: spec
	<version: '1.3' imports: #('1.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'StuartHerring'.
		spec timestamp: '6/16/2012 16:17'.
		spec project: 'OSProcess' with: '4.4.5'.
		spec 
			package: 'Collections-BTree' with: 'Collections-BTree-lr.73';
			package: 'Ma-Core' with: 'Ma-Core-cmm.214';
			package: 'Ma-Collections' with: 'Ma-Collections-cmm.132';
			package: 'Ma-Ascii-Report' with: 'Ma-Ascii-Report-cmm.9';
			package: 'Ma-Statistics' with: 'Ma-Statistics-cmm.28';
			package: 'Ma-Search' with: 'Ma-Search-cmm.40';
			package: 'Ma-Serializer-Core' with: 'Ma-Serializer-Core-cmm.278';
			package: 'Ma-Serializer-Tests' with: 'Ma-Serializer-Tests-cmm.40';
			package: 'Ma-Client-Server-Core' with: 'Ma-Client-Server-Core-cmm.220';
			package: 'Ma-Client-Server-Tester' with: 'Ma-Client-Server-Tester-cmm.156';
			package: 'WriteBarrier' with: 'WriteBarrier-cmm.35';
			package: 'SOLHashTables' with: 'SOLHashTables-cmm.16';
			package: 'Magma-Client' with: 'Magma-Client-cmm.605';
			package: 'Magma-Server' with: 'Magma-Server-cmm.444';
			package: 'Magma-Tools' with: 'Magma-Tools-cmm.64';
			package: 'Magma-Tester' with: 'Magma-Tester-cmm.395'. ].

	spec for: #'pharo' do: [
		spec 
			package: 'Ma-Serializer-Pharo-Core' with: 'Ma-Serializer-Pharo-Core-cmm.1';
			package: 'Magma-Pharo-Tester' with: 'Magma-Pharo-Tester-cmm.1' ].
! !

!ConfigurationOfMagmaPharo methodsFor: 'versions' stamp: 'StuartHerring 1/16/2013 08:23'!
version14: spec
	<version: '1.4' imports: #('1.4-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'Update to 1.4
Committed fixes for issue 1 and issue 5'.
		spec author: 'StuartHerring'.
		spec timestamp: '1/16/2013 08:23'.
		spec project: 'OSProcess' with: '4.4.5'.
		spec 
			package: 'BrpExtensions' with: 'BrpExtensions-cmm.11';
			package: 'Collections-BTree' with: 'Collections-BTree-lr.73';
			package: 'Ma-Core' with: 'Ma-Core-cmm.232';
			package: 'Ma-Collections' with: 'Ma-Collections-cmm.141';
			package: 'Ma-Ascii-Report' with: 'Ma-Ascii-Report-cmm.9';
			package: 'Ma-Statistics' with: 'Ma-Statistics-cmm.28';
			package: 'Ma-Search' with: 'Ma-Search-cmm.42';
			package: 'Ma-Serializer-Core' with: 'Ma-Serializer-Core-StuartHerring.293';
			package: 'Ma-Serializer-Tests' with: 'Ma-Serializer-Tests-cmm.40';
			package: 'Ma-Client-Server-Core' with: 'Ma-Client-Server-Core-cmm.225';
			package: 'Ma-Client-Server-Tester' with: 'Ma-Client-Server-Tester-cmm.157';
			package: 'WriteBarrier' with: 'WriteBarrier-cmm.44';
			package: 'SOLHashTables' with: 'SOLHashTables-cmm.16';
			package: 'Magma-Client' with: 'Magma-Client-cmm.642';
			package: 'Magma-Server' with: 'Magma-Server-cmm.455';
			package: 'Magma-Tools' with: 'Magma-Tools-cmm.68';
			package: 'Magma-Tester' with: 'Magma-Tester-StuartHerring.407'. ].

	spec for: #'pharo' do: [
		spec 
			package: 'Ma-Serializer-Pharo-Core' with: 'Ma-Serializer-Pharo-Core-cmm.1';
			package: 'Magma-Pharo-Tester' with: 'Magma-Pharo-Tester-cmm.1'. ].
! !
